// AMD Format - allows comments
// wrapped data should be JSON compatible
define([], {

	"debug": {
		"colliders":false
	},

	// GAMEPLAY PARAMETERS
	"gameplay": {

		"controls":
		{
			// Keyboard keys
			"keyboard":
			{
				"action":"space"
			}
		},

		// Player gameplay Defaults
		"player":
		{
			maxSpeed: 15,
			minLaunchSpeed: 15,
			maxLaunchSpeed: 32,
			gravityAir: 0.5,
			gravityWater: 0.2,
			diveDelay:500, // Miliseconds to return to normal bounce factor after diving
			bounceFactor: 0.7, // Multiplies all bounces when not diving by this value
			diveBounceFactor:1.1, // Multiplies all bounces when DIVING by this value
			diveGravity: 5, // gravity multiplier
			decelerationAir:1,
			decelerationWater:0.98,
			waterBounce: 22,
			waterBounceDecel:4,
			maxRocketBoost:0, // Boosts available when almost stopped (defined in upgrades)
			rocketBoostMinVelocity:15 // Minimum player velocity to allow use of rocket boost
		},

		"upgrades":
		{
			"ramp": [
				{"price":0,  "ramp":"ramp1", "launchStat":0},
				{"price":50, "ramp":"ramp2", "launchStat":1},
				{"price":350,"ramp":"ramp3", "launchStat":2},
				{"price":950,"ramp":"ramp4", "launchStat":3}
			],
			"slingshot": [
				{"price":0,   "ramp":"ramp1", "player": {"minLaunchSpeed": "*=1.0", "maxLaunchSpeed": "*=1.0", "maxSpeed": "*=1.10"}, "launchStat":0},
				{"price":50,  "ramp":"ramp2", "player": {"minLaunchSpeed": "*=1.2", "maxLaunchSpeed": "*=1.2", "maxSpeed": "*=1.15"}, "launchStat":1},
				{"price":350, "ramp":"ramp3", "player": {"minLaunchSpeed": "*=1.4", "maxLaunchSpeed": "*=1.4", "maxSpeed": "*=1.20"}, "launchStat":2},
				{"price":950, "ramp":"ramp4", "player": {"minLaunchSpeed": "*=1.6", "maxLaunchSpeed": "*=1.6", "maxSpeed": "*=1.25"}, "launchStat":3}
			],
			"boost": [
				{"price":0,   "player": {"maxRocketBoost": 0}, "launchStat":0},
				{"price":50,  "player": {"maxRocketBoost": 1}, "launchStat":1},
				{"price":350, "player": {"maxRocketBoost": 2}, "launchStat":2},
				{"price":950, "player": {"maxRocketBoost": 3}, "launchStat":3}
			]
		},

		"powerups": {
			// Rocketboost gameplay params
			"power1":
			{
				"angle":15,"boost":15
			},
			"power2":
			{
				"angle":18,"boost":20
			},
			"power3":
			{
				"angle":25,"boost":30
			}
		},

		// Ramps launch data
		"ramps": {
			"ramp1": {
				"power":1, // Player min and max launch speed multiplier
				"powerRotationSpeed":0.05, // Power rotation per frame, from -1 to 1
				"playerRotation":-30, // Player rotation at the end
				"launchAngle":50, // Launch angle
				"minSpeed": 0.03, // minimum progress per frame
				"maxSpeed":0.07, // maximum progress per frame, will be multiplied with the power
			},
			// TIKI Ramp
			"ramp2": {
				"power":1, 
				"powerRotationSpeed":0.05, 
				"playerRotation":-30,
				"launchAngle":45,
				"minSpeed": 0.03,
				"maxSpeed":0.07,
			},
			// PLUMBER METAL Ramp
			"ramp3": {
				"power":1, 
				"powerRotationSpeed":0.05, 
				"playerRotation":-30,
				"launchAngle":36,
				"minSpeed": 0.04,
				"maxSpeed":0.09,
			},
			"ramp4": {
				"power":1, 
				"powerRotationSpeed":0.05, 
				"playerRotation":-30,
				"launchAngle":33,
				"minSpeed": 0.04,
				"maxSpeed":0.09,
			}
		},

		"characters":
		{
			"menuOrder": ["jack","crash","milo","pnf","wander","randy","leo","kno"],

			// Fish Hooks - Milo
			"milo": {
				// Player mods
				// relative units, ie: double the speed = "*2", half speed: = "*0.5"
				"maxSpeed": "*=1.0",
				"minLaunchSpeed": "*=1.0",
				"maxLaunchSpeed": "*=1.0",
								
				"gravityAir": "*=1.3",
				"waterBounceDecel": "*=1.0",
				"diveGravity": "*=1.3",
				
				// Menu stats
				"float" : 1,
				"inertia" : 2,
				"speed" : 3,
				"brand": "FishHooks"
			},

			// Kickin’ It - Jack
			"jack": {
				// Player mods
				"maxSpeed": "*=0.8",
				"minLaunchSpeed": "*=1.0",
				"maxLaunchSpeed": "*=1.0",
				
				"gravityAir": "*=1.0",
				"waterBounceDecel": "*=0.7",
				"diveGravity": "*=0.7",
				
				
				// Menu stats
				"float" : 2,
				"inertia" : 3,
				"speed" : 1,
				"brand": "KickinIt"
			},

			// Crash & Bernstein - Crash
			"crash": {
				// Player mods
				"maxSpeed": "*=0.8",
				"minLaunchSpeed": "*=1.0",
				"maxLaunchSpeed": "*=1.0",
				
				"gravityAir": "*=1.3",
				"waterBounceDecel": "*=0.7",
				"diveGravity": "*=1.0",
				
				// Menu stats
				"float" : 1,
				"inertia" : 3,
				"speed" : 2,
				"brand": "CrashAndBernstein"
			},

			// Phineas & Ferb - Phineas and Ferb
			"pnf": {
				// Player mods
				"maxSpeed": "*=1.1", // relative units, ie: double the speed = "*2", half speed: = "*0.5"
				"minLaunchSpeed": "*=1.0",
				"maxLaunchSpeed": "*=1.0",
				
				"gravityAir": "*=1.15",
				"waterBounceDecel": "*=1.3",
				"diveGravity": "*=1.3",
				
				// Menu stats
				"float" : 2,
				"inertia"	: 1,
				"speed" : 3,
				"brand": "PhineasAndFerb"
			},

			// Wander Over Yonder - Wander
			"wander": {
				// Player mods
				"maxSpeed": "*=1.1", // relative units, ie: double the speed = "*2", half speed: = "*0.5"
				"minLaunchSpeed": "*=1.0",
				"maxLaunchSpeed": "*=1.0",
				
				"gravityAir": "*=1.0",
				"waterBounceDecel": "*=1.0",
				"diveGravity": "*=0.7",
				
				// Menu stats
				"float" : 3,
				"inertia"	: 2,
				"speed" : 1,
				"brand": "WanderOverYonder"
			},

			// Randy Cunningham - Randy
			"randy": {
				// Player mods
				"maxSpeed": "*=1.1", // relative units, ie: double the speed = "*2", half speed: = "*0.5"
				"minLaunchSpeed": "*=1.0",
				"maxLaunchSpeed": "*=1.0",
				
				"gravityAir": "*=1.0",
				"waterBounceDecel": "*=1.3",
				"diveGravity": "*=1.0",
				
				// Menu stats
				"float" : 3,
				"inertia"	: 1,
				"speed" : 2,
				"brand": "RandyCunningham"
			},

			// Lab Rats - Leo
			"leo": {
				// Player mods
				"maxSpeed": "*=1.1", // relative units, ie: double the speed = "*2", half speed: = "*0.5"
				"minLaunchSpeed": "*=1.0",
				"maxLaunchSpeed": "*=1.0",
				
				"gravityAir": "*=1.3",
				"waterBounceDecel": "*=0.7",
				"diveGravity": "*=1.0",
				
				// Menu stats
				"float" : 1,
				"inertia"	: 3,
				"speed" : 2,
				"brand": "LabRats"
			},

			// Mighty Med - Kaz and Oliver
			"kno": {
				// Player mods
				"maxSpeed": "*=1.1", // relative units, ie: double the speed = "*2", half speed: = "*0.5"
				"minLaunchSpeed": "*=1.0",
				"maxLaunchSpeed": "*=1.0",
				
				"gravityAir": "*=1.0",
				"waterBounceDecel": "*=1.0",
				"diveGravity": "*=1.3",
				
				// Menu stats
				"float" : 1,
				"inertia"	: 2,
				"speed" : 3,
				"brand": "MightyMed"
			}

		},

		"gpi": {
			"shark1": {
				// How much Y velocity added or removed to the player (pixels per frame)
				"bounce":22,

				// How much X velocity added or removed to the player
				"boost":0,

				// The speed of the shark travel
				"speed":0.5,

				// How much points
				"points":25,
				"tags":"friendly"
			},
			"shark2": {
				"bounce":22,
				"boost":0,
				"speed":0.7,
				"points":25,
				"tags":"friendly"
			},
			"boat_shark": {
				"bounce":24,
				"boost":5,
				"minSpeed":4,
				"maxSpeed":8,
				"points":100,
				"tags":"friendly"
			},
			"balloon1": {
				"bounce":24,
				"boost":0,
				"speed":0,
				"points":50,
				"tags":"friendly"
			},
			"balloon1": {
				"bounce":24,
				"boost":0,
				"speed":0,
				"points":50,
				"tags":"friendly"
			},

			// Obstacles
			"shark_net": {
				"points":0,
				"speed":0.3,
				"tags":"obstacle"
			},

			// Secondary Characters
			"sec_wyatt": {
				"bounce":30,
				"boost":3,
				"speed":0,
				"points":150,
				"tags":"secondary"
			},
			"sec_falafel": {
				"bounce":30,
				"boost":3,
				"speed":0,
				"points":150,
				"tags":"secondary"
			},
			"sec_candace": {
				"bounce":28,
				"boost":4,
				"speed":0,
				"points":150,
				"tags":"secondary"
			},
			"sec_jocktopus": {
				"bounce":28,
				"boost":4,
				"speed":0,
				"points":150,
				"tags":"secondary"
			},
			"sec_megahertz": {
				"bounce":30,
				"boost":3,
				"speed":0,
				"points":150,
				"tags":"secondary"
			},
			"sec_hater": {
				"bounce":28,
				"boost":4,
				"speed":0,
				"points":150,
				"tags":"secondary"
			},
			"sec_adam": {
				"bounce":28,
				"boost":4,
				"speed":0,
				"points":150,
				"tags":"secondary"
			},
			"sec_mcfist": {
				"bounce":28,
				"boost":4,
				"speed":0,
				"points":150,
				"tags":"secondary"
			},
		}
	},

	// LEVELS
	"levels": {

		// LEVEL START SEQUENCE, ONLY ONE WILL BE CHOSE RANDOMLY
		"level_0": {

			// Horizontal space between objects (random between min and max)
			"spacing":{
				"min":50,
				"max":100
			},

			// LEVEL SEQUENCES
			"sequences": [
				["shark1","random_friendly","shark2","boat_shark","balloon1","shark2","boat_floater","shark1","random_friendly_secondary","shark2","boat_shark","balloon1","shark1"],
				["random_friendly","shark1","boat_shark","shark2","boat_shark","shark1","random_friendly_secondary","shark1","shark2","random_friendly","shark1"]
			]
		},
		// DIFFICULTY 1
		"level_1": {
			"distance":0,

			// Horizontal space between objects (random between min and max)
			"spacing":{
				"min":50,
				"max":300
			},

			// LEVEL SEQUENCES
			"sequences": [
				["shark1","random_friendly_secondary","shark2","boat_shark","shark2","boat_floater","random_secondary","shark1","random_friendly","shark2","boat_shark","balloon1","random_friendly_secondary"],
				["random_friendly","shark2","shark1","boat_shark","boat_floater","random_friendly","random_secondary","shark1","shark2","random_friendly_secondary","shark1"]
			]
		},
		// DIFFICULTY 2
		"level_2": {
			"distance":300, // Distance in meters when difficulty level will start

			// Horizontal space between objects (random between min and max)
			"spacing":{
				"min":100,
				"max":550
			},

			// LEVEL SEQUENCES
			"sequences": [
				["shark1","random","shark2","boat_shark","shark1","random","random_secondary","shark2","boat_floater","shark1","random","shark2","boat_shark","balloon1"],
				["random","shark1","boat_shark","boat_floater","empty_400","random_secondary","random","random","shark1","shark2","random","shark1"]
			]
		},
		// DIFFICULTY 3
		"level_3": {
			"distance":400, // Distance in meters when difficulty level will start

			// Horizontal space between objects (random between min and max)
			"spacing":{
				"min":150,
				"max":800
			},

			// LEVEL SEQUENCES
			"sequences": [
				["shark1","random","shark2","boat_shark","random_obstacle","random_secondary","shark2","boat_floater","shark1","random","shark2","boat_shark","balloon1"],
				["random","shark1","boat_shark","boat_floater","empty_400","random_secondary","random","random_obstacle","shark1","shark2","random","shark1"]
			]
		}
	}
});